



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LCA 最近公共祖先 tarjan离线 总结 结合3个例题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LCA 最近公共祖先 tarjan离线 总结 结合3个例题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 01:08:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在网上找了一些对tarjan算法解释较好的文章 并加入了自己的理解</p>
<p>LCA（Least Common Ancestor），顾名思义，是指在一棵树中，距离两个点最近的两者的公共节点。也就是说，在两个点通往根的道路上，肯定会有公共的节点，我们就是要求找到公共的节点中，深度尽量深的点。还可以表示成另一种说法，就是如果把树看成是一个图，这找到这两个点中的最短距离。</p>
<p>LCA算法有在线算法也有离线算法，所谓的在线算法就是实时性的，比方说，给你一个输入，算法就给出一个输出，就像是http请求，请求网页一样。给一个实时的请求，就返回给你一个请求的网页。而离线算法则是要求一次性读入所有的请求，然后在统一得处理。而在处理的过程中不一定是按照请求的输入顺序来处理的。说不定后输入的请求在算法的执行过程中是被先处理的。</p>
<p>本文先介绍一个离线的算法，就做tarjan算法。这个算法是基于并查集和DFS的。Dfs的作用呢，就是递归，一次对树中的每一个节点进行处理。而并查集的作用就是当dfs每访问完（注意，这里是访问完）到一个点的时候，就通过并查集将这个点，和它的子节点链接在一起构成一个集合，也就是将并查集中的pnt值都指向当前节点。这样就把树中的节点分成了若干个的集合，然后就是根据这些集合的情况来对输入数据来进行处理。</p>
<p>比方说当前访问到的节点是u，等u处理完之后呢，ancestor[u]就构成了u的集合中的点与u点的LCA，而ancestor[fa[u]]就构成了，u的兄弟节点及其兄弟子树的集合中点与u的LCA，而ancestor[fa[fa[u]]]就构成了u的父亲节点的兄弟节点及其兄弟子树的集合中的点与u的LCA。然后依次类推，这样就构成了这个LCA的离线算法。</p>
<p>以上来自 pursuit的专栏</p>
<p>首先，Tarjan算法是一种离线算法，也就是说，它要首先读入所有的询问（求一次LCA叫做一次询问），然后并不一定按照原来的顺序处理这些询问。而打乱这个顺序正是这个算法的巧妙之处。看完下文，你便会发现，如果偏要按原来的顺序处理询问，Tarjan算法将无法进行。</p>
<pre class="prettyprint linenums">  Tarjan算法是利用并查集来实现的。它按DFS的顺序遍历整棵树。对于每个结点x，它进行以下几步操作：<br />
   * 计算当前结点的层号lv[x]，并在并查集中建立仅包含x结点的集合，即root[x]:=x。<br />
   * 依次处理与该结点关联的询问。<br />
   * 递归处理x的所有孩子。<br />
   * root[x]:=root[father[x]]（对于根结点来说，它的父结点可以任选一个，反正这是最后一步操作了）。
</pre>
<p>现在我们来观察正在处理与x结点关联的询问时并查集的情况。由于一个结点处理完毕后，它就被归到其父结点所在的集合，所以在已经处理过的结点中（包括 x本身），x结点本身构成了与x的LCA是x的集合，x结点的父结点及以x的所有已处理的兄弟结点为根的子树构成了与x的LCA是father[x]的集合，x结点的父结点的父结点及以x的父结点的所有已处理的兄弟结点为根的子树构成了与x的LCA是father[father[x]]的集合&hellip;&hellip;（上面这几句话如果看着别扭，就分析一下句子成分，也可参照右面的图）假设有一个询问(x,y)（y是已处理的结点），在并查集中查到y所属集合的根是z，那么z 就是x和y的LCA，x到y的路径长度就是lv[x]+lv[y]-lv[z]*2。累加所有经过的路径长度就得到答案。 现在还有一个问题：上面提到的询问(x,y)中，y是已处理过的结点。那么，如果y尚未处理怎么办？其实很简单，只要在询问列表中加入两个询问(x, y)、(y,x)，那么就可以保证这两个询问有且仅有一个被处理了（暂时无法处理的那个就pass掉）。而形如(x,x)的询问则根本不必存储。  如果在并查集的实现中使用路径压缩等优化措施，一次查询的复杂度将可以认为是常数级的，整个算法也就是线性的了。</p>
<div>上面内容来自NOCOW</div>
<div>TarjanLCA的递归过程就是深度优先搜索。</div>
<div> 
 </div>
<div>
  Tarjan作为离线off-line算法，在程序开始前，需要将所有等待询问的节点对提前存储，然后程序从树根开始执行TarjanLCA()。假如有如下一棵多叉树
 </div>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130617110525359" /></p>
<p>根据TarjanLCA的实现算法可以看出，只有当某一棵子树全部遍历处理完成后，才将该子树的根节点标记为黑色（初始化是白色），假设程序按上面的树形结构进行遍历，首先从节点1开始，然后递归处理根为2的子树，当子树2处理完毕后，节点2， 5， 6均为黑色；接着要回溯处理3子树，首先被染黑的是节点7（因为节点7作为叶子不用深搜，直接处理），接着节点7就会查看所有询问(7, x)的节点对，假如存在(7, 5)，因为节点5已经被染黑，所以就可以断定(7, 5)的最近公共祖先就是find(5).ancestor，即节点1（因为2子树处理完毕后，子树2和节点1进行了union，find(5)返回了合并后的树的根1，此时树根的ancestor的值就是1）。 &nbsp; &nbsp;有人会问如果没有(7, 5)，而是有(5, 7)询问对怎么处理呢？我们可以在程序初始化的时候做个技巧，将询问对(a, b)和(b, a)全部存储，这样就能保证完整性</p>
<p>参考&nbsp;&nbsp; <a href="http://blog.chinaunix.net/uid/1721137.html" rel="external nofollow noreferrer">applesun</a></p>
<p>下面这幅图可以让大家有个感性的认识&nbsp;&nbsp; BY hnust_xiehonghao</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130617120927656" /></p>
<p>下面是一个最基础的LCA题目&nbsp;&nbsp; &nbsp;<a href="http://poj.org/problem?id=1330" rel="external nofollow noreferrer">http://poj.org/problem?id=1330</a></p>
<p>赤裸裸的 题意 输入cas 后&nbsp; 有cas组数据 输入 n&nbsp;&nbsp; 再输入n-1 条边&nbsp;&nbsp;&nbsp; 之后输入x y&nbsp; 问x y的最近公共祖先是什么</p>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;string.h&gt;<br />
using namespace std;<br />
#define Size 11111  //节点个数

vector&lt;int&gt; node[Size],que[Size];<br />
int n,pare[Size],anse[Size],in[Size],rank[Size];

int vis[Size];<br />
void init()<br />
{<br />
	int i;<br />
	for(i=1;i&lt;=n;i++)<br />
	{<br />
		node[i].clear();<br />
		que[i].clear();<br />
		rank[i]=1;<br />
		pare[i]=i;///<br />
	}<br />
	memset(vis,0,sizeof(vis));<br />
	memset(in,0,sizeof(in));<br />
	memset(anse,0,sizeof(anse));

}

int find(int nd)//并查集操作  不解释<br />
{<br />
	return pare[nd]==nd?nd:pare[nd]=find(pare[nd]);<br />
}<br />
int Union(int nd1,int nd2)//并查集操作  不解释<br />
{<br />
	int a=find(nd1);<br />
	int b=find(nd2);<br />
	if(a==b) return 0;<br />
	else if(rank[a]&lt;=rank[b])<br />
	{<br />
		pare[a]=b;<br />
		rank[b]+=rank[a];<br />
	}<br />
	else<br />
	{<br />
		pare[b]=a;<br />
		rank[a]+=rank[b];<br />
	}<br />
	return 1;

}

void LCA(int root)<br />
{<br />
	int i,sz;<br />
	anse[root]=root;//首先自成一个集合<br />
	sz=node[root].size();<br />
	for(i=0;i&lt;sz;i++)<br />
	{<br />
		   LCA(node[root][i]);//递归子树<br />
		   Union(root,node[root][i]);//将子树和root并到一块<br />
		 anse[find(node[root][i])]=root;//修改子树的祖先也指向root<br />
	}<br />
	vis[root]=1;<br />
	sz=que[root].size();<br />
	for(i=0;i&lt;sz;i++)<br />
	{<br />
            if(vis[que[root][i]])<br />
			{<br />
				printf("%d\n",anse[find(que[root][i])]);///root和que[root][i]所表示的值的最近公共祖先<br />
				return ;<br />
			}<br />
	}<br />
     return ;<br />
}

int main()<br />
{<br />
	int cas,i;<br />
	scanf("%d",&amp;cas);<br />
	while(cas--)<br />
	{<br />
		int s,e;<br />
		scanf("%d",&amp;n);<br />
		init();<br />
		for(i=0;i&lt;n-1;i++)<br />
		{<br />
			scanf("%d %d",&amp;s,&amp;e);<br />
			if(s!=e)<br />
			{<br />
			    node[s].push_back(e);<br />
			   // node[e].push_back(s);<br />
				in[e]++;<br />
			}<br />
		}<br />
		scanf("%d %d",&amp;s,&amp;e);<br />
		que[s].push_back(e);<br />
		que[e].push_back(s);<br />
		for(i=1;i&lt;=n;i++)  if(in[i]==0) break;//寻找根节点<br />
	//	printf("root=%d\n",i);<br />
		LCA(i);<br />
	}<br />
	return 0;<br />
}</pre>
<p>之后来个加强版</p>
<p><a href="http://acm.hdu.edu.cn/showproblem.php?pid=4547" rel="external nofollow noreferrer">http://acm.hdu.edu.cn/showproblem.php?pid=4547</a>&nbsp; CD操作&nbsp; hdu4547</p>
<p><strong>思路：</strong></p>
<p>求出a和b的最近公共祖先,然后分4种情况讨论</p>
<p>①. a和b有一个公共祖先c，则用 c时间戳-a的时间戳+1(1步可以直接从c到b)</p>
<p>②. a是b的祖先，则只用1步就可以到达b点</p>
<p>③. b是a的祖先，则用a的时间戳-b的时间戳</p>
<p>④. a和b是同一个点，则答案是0</p>
<p>参考&nbsp; <a href="http://www.cnblogs.com/Griselda/archive/2013/06/05/3119265.html" rel="external nofollow noreferrer">http://www.cnblogs.com/Griselda/archive/2013/06/05/3119265.html</a></p>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;string.h&gt;<br />
#include&lt;map&gt;<br />
#include&lt;math.h&gt;<br />
#include&lt;string&gt;<br />
using namespace std;<br />
#define Size 111111  //节点个数<br />
struct Query<br />
{<br />
    int nd,id;<br />
}temp;<br />
struct out<br />
{<br />
    int s,e;<br />
}out[Size];<br />
vector&lt;int&gt; node[Size];<br />
vector&lt;struct Query&gt;que[Size];<br />
int n,m,pare[Size],ance[Size],in[Size],rank[Size],dis[Size],ans[Size],vis[Size];<br />
map&lt;string,int&gt;mp;<br />
void init()<br />
{<br />
	int i;<br />
	for(i=1;i&lt;=n;i++)<br />
	{<br />
		node[i].clear();<br />
		que[i].clear();<br />
		rank[i]=1;<br />
		pare[i]=i;///<br />
	}<br />
	memset(vis,0,sizeof(vis));<br />
	memset(in,0,sizeof(in));<br />
	memset(ance,0,sizeof(ance));<br />
	memset(dis,0,sizeof(dis));<br />
	mp.clear();<br />
}<br />
int aabs(int aa)<br />
{<br />
     if(aa&gt;0) return aa;<br />
     else return -aa;<br />
}<br />
int find(int nd)//并查集操作  不解释<br />
{<br />
	return pare[nd]==nd?nd:pare[nd]=find(pare[nd]);<br />
}<br />
int Union(int nd1,int nd2)//并查集操作  不解释<br />
{<br />
	int a=find(nd1);<br />
	int b=find(nd2);<br />
	if(a==b) return 0;<br />
	else if(rank[a]&lt;=rank[b])<br />
	{<br />
		pare[a]=b;<br />
		rank[b]+=rank[a];<br />
	}<br />
	else<br />
	{<br />
		pare[b]=a;<br />
		rank[a]+=rank[b];<br />
	}<br />
	return 1;<br />
}<br />
void LCA(int root,int num)<br />
{<br />
	int i,sz;<br />
	ance[root]=root;//首先自成一个集合<br />
	dis[root]=num;<br />
	sz=node[root].size();<br />
	for(i=0;i&lt;sz;i++)<br />
	{<br />
		   LCA(node[root][i],num+1);//递归子树<br />
		   Union(root,node[root][i]);//将子树和root并到一块<br />
		 ance[find(node[root][i])]=root;//修改子树的祖先也指向root<br />
	}<br />
	vis[root]=1;<br />
	sz=que[root].size();<br />
	for(i=0;i&lt;sz;i++)<br />
	{<br />
	    int nd1,nd2,idx,ancestor;<br />
	    nd1=root;nd2=que[root][i].nd;idx=que[root][i].id;<br />
            if(vis[nd2])<br />
			{<br />
                  ans[idx]=ance[find(nd2)];<br />
			}<br />
	}<br />
     return ;<br />
}

int main()<br />
{<br />
	int cas,i;<br />
	scanf("%d",&amp;cas);<br />
	while(cas--)<br />
	{<br />
		char  ss[100],ee[100];<br />
		int s,e,cnt=1;<br />
		scanf("%d %d",&amp;n,&amp;m);<br />
		init();<br />
		for(i=0;i&lt;n-1;i++)<br />
		{<br />
			scanf("%s %s",ee,ss);<br />
			if(mp.find(ss)==mp.end())<br />
            {<br />
                 s=cnt;mp[ss]=cnt++;<br />
            }<br />
            else s=mp[ss];<br />
			if(mp.find(ee)==mp.end())<br />
            {<br />
                e=cnt;mp[ee]=cnt++;<br />
            }<br />
            else  e=mp[ee];<br />
			if(s!=e)<br />
			{<br />
			    node[s].push_back(e);<br />
				in[e]++;<br />
			}<br />
		}<br />
		for(i=0;i&lt;m;i++)<br />
        {<br />
		   scanf("%s %s",ss,ee);<br />
		   s=mp[ss];e=mp[ee];<br />
		   out[i].s=s;out[i].e=e;<br />
		   temp.nd=e;temp.id=i;<br />
		   que[s].push_back(temp);<br />
		   temp.nd=s;temp.id=i;<br />
		   que[e].push_back(temp);<br />
        }<br />
		for(i=1;i&lt;=n;i++)  if(in[i]==0) break;//寻找根节点<br />
		LCA(i,0);<br />
		for(i=0;i&lt;m;i++)<br />
        {<br />
            if(out[i].s==out[i].e)<br />
                printf("0\n");<br />
            else<br />
                if(out[i].s==ans[i])<br />
                      printf("1\n");<br />
            else if(out[i].e==ans[i])<br />
                printf("%d\n",dis[out[i].s]-dis[ans[i]]);<br />
            else<br />
            printf("%d\n",dis[out[i].s]-dis[ans[i]]+1);<br />
        }<br />
	}<br />
	return 0;<br />
}
</pre>
<p>by hnust_xiehonghao</p>
<p>hdu&nbsp;&nbsp; 2874</p>
<p>http://acm.hdu.edu.cn/showproblem.php?pid=2874</p>
<p>题目大意: 给你一个n个节点m条边的森林，再给定q个查询，每次查询森林里两个点的最近距离。n ,m &lt;= 10000,q &lt;= 100万</p>
<p>本题和标准的LCA模板应用有了不小的区别&nbsp;&nbsp; 却可以让人更加透彻的看清LCA的思路&nbsp; 而且本题没有必要去求出公共祖先</p>
<p>具体看代码</p>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;string.h&gt;<br />
#include&lt;vector&gt;<br />
using namespace std;<br />
#define Size  11111<br />
struct Edge<br />
{<br />
    int y,val;<br />
}temp;<br />
struct Query<br />
{<br />
    int y,id;<br />
}mid;<br />
int pare[Size],ance[Size],vis[Size],dis[Size],rank[Size],ans[1000000+100],n,m,c,tree[Size];<br />
vector&lt;struct Query&gt;que[Size];<br />
vector&lt;struct Edge&gt;node[Size];<br />
void init()<br />
{<br />
    int i;<br />
    for(i=0;i&lt;=n;i++)<br />
    {<br />
        vis[i]=0;<br />
        pare[i]=i;<br />
        dis[i]=0;<br />
        rank[i]=1;<br />
        que[i].clear();<br />
        node[i].clear();<br />
    }<br />
    memset(ans,-1,sizeof(ans));<br />
}<br />
int find(int x)<br />
{<br />
    return pare[x]==x?x:pare[x]=find(pare[x]);<br />
}<br />
/*<br />
void Union(int x,int y)<br />
{<br />
x=find(x);<br />
y=find(y);<br />
if(x!=y)<br />
{<br />
if(rank[x]&gt;rank[y])<br />
{<br />
rank[x]+=rank[y];<br />
pare[y]=x;<br />
}<br />
else<br />
{<br />
rank[y]+=rank[x];<br />
pare[x]=y;<br />
}<br />
}<br />
}<br />
*/<br />
void LCA(int root,int d,int k)//k表示是以第k个点作为根的树<br />
{<br />
    int i,sz,nd1,nd2;<br />
    vis[root]=1; //已经遍历过的点 要标记一下 不要<br />
    tree[root]=k;dis[root]=d;<br />
    // ance[root]=root;<br />
    sz=node[root].size();<br />
    for(i=0;i&lt;sz;i++)<br />
    {<br />
        nd2=node[root][i].y;<br />
        if(!vis[nd2])<br />
        {<br />
            LCA(nd2,d+node[root][i].val,k);<br />
            // Union(node[root][i].y,root);//用带rank的幷查集操作答案不对 不知道why<br />
            int w=find(nd2),m=find(root);<br />
            if(w!=m)<br />
            {<br />
               pare[w]=m;//这样才对<br />
            }<br />
            //ance[find(node[root][i].y)]=root;<br />
        }<br />
    }<br />
    sz=que[root].size();<br />
    for(i=0;i&lt;sz;i++)<br />
    {<br />
        nd1=root;<br />
        nd2=que[root][i].y;<br />
        if(vis[nd2]&amp;&amp;tree[nd1]==tree[nd2])//如果 nd1 nd2 的跟是同一个点 则是同一棵树上的<br />
        {<br />
            ans[que[root][i].id]=dis[nd1]+dis[nd2]-2*dis[find(nd2)];<br />
        }<br />
    }<br />
}<br />
int main()<br />
{<br />
    int i,j,x,y,val;<br />
    while(scanf("%d %d %d",&amp;n,&amp;m,&amp;c)!=EOF)<br />
    {<br />
        init();<br />
        for(i=0;i&lt;m;i++)<br />
        {<br />
            scanf("%d %d %d",&amp;x,&amp;y,&amp;val);<br />
            if(x!=y)<br />
            {<br />
                temp.y=y;temp.val=val;<br />
                node[x].push_back(temp);<br />
                temp.y=x;<br />
                node[y].push_back(temp);//路是2个方向都可以通行的<br />
            }<br />
        }<br />
        for(i=0;i&lt;c;i++)<br />
        {<br />
            scanf("%d %d",&amp;x,&amp;y);<br />
            mid.id=i;<br />
            mid.y=y;<br />
            que[x].push_back(mid);<br />
            mid.y=x;<br />
            que[y].push_back(mid);<br />
        }<br />
        for(i=1;i&lt;=n;i++)<br />
        {<br />
            LCA(i,0,i);//以每一个节点作为根节点去深度搜索  找出每个点作为根的所有最近公共祖先<br />
        }<br />
        for(i=0;i&lt;c;i++)<br />
        {<br />
            if(ans[i]==-1)<br />
                printf("Not connected\n");<br />
            else<br />
                printf("%d\n",ans[i]);<br />
        }<br />
    }<br />
    return 0;<br />
}<br />
/*本题给的是一个森林 而不是一颗树，由于在加入边的时候，我们让2个方向都能走 这样就<br />
形成了一个强连通的快，  对于这个快来说，不管从快上那点出发 都可以遍历这个快上的所<br />
有的点，且相对距离是一样的*/
</pre>
<p>待续 。。。。。。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq445nqz.html">JVM类加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jv26g9.html">CentOS添加用户及赋予sudo权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/3900ywn9.html">两个本地&lpar;localhost&rpar;html文件之间的传值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1ye78.html">python爬取某些网站出错的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnwx62q.html">0环境设置 - AUTOTRACE设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmrmlz9.html">Side-by-side assembly</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn101r28.html">ZOJ 3705 Applications</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xk26g9.html">android&lowbar;自定义布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvg7doq.html">《转》java动态代理（JDK和cglib）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj1r2k9.html">Append和AppendTo</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzje0g8.html">C&plus;&plus;创建对象的三种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyd30e9.html">python中os&period;path&period;isdir&lpar;&rpar;函数的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rpvx58.html">cookie猜数字游戏（上）---------------思路分析（踩坑）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gjje0q.html">Oracle 口令文件：即 oracle密码文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllr10eq.html">dbm&period;error&colon; need &amp;&num;39&semi;c&amp;&num;39&semi; or &amp;&num;39&semi;n&amp;&num;39&semi; flag to open new db</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25p6zoq.html">批处理taskkill运行结束不掉程序以及停留问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvp0nj8.html">关于New，delete</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4n3vx9.html">Ajax异步提交造成变量undefined</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w0kenq.html">Vue：v-on自定义事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pom0w8.html">springboot&plus;mybatis结合使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zogmldq.html">《大象UML》看书笔记2：</a>
			</li>
						<li><a href="https://www.batexi.com/a/8memoy2q.html">delphi模态窗体最小化会隐藏的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jd7vv8.html">&lbrack;代码示例&rsqb;用Fine Uploader&plus;ASP&period;NET MVC实现ajax文件上传</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1v56yq.html">Git本地分支版本号过低导致的push错误 error&colon; failed to push some refs to &period;&period;&period; 及兴许amend</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pop4j8.html">MEAN栈开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1dyr2q.html">Android之一个简单计算器源代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mvrl38.html">基于visual Studio2013解决C语言竞赛题之1062高与矮</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpew1jq.html">Boost&colon;&colon;thread库的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojk171q.html">九度OnlineJudge之1018：统计同成绩学生人数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljm1719.html">web攻击方式和防御方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
